// makes N*log_3(N) queries

#include <iostream>
#include <vector>
using namespace std;

int main() {
	int n, k; cin >> n >> k;

	vector<int> s = {1, n}; // we know p[1] < p[n]
	for (int i = 2; i < n; ++i) {
		int j1 = 0, j2 = s.size();
		while (j2 - j1 > 2) {
			int d = (j2 - j1) / 3;
			int k1 = j1 + d, k2 = k1 + d;
			cout << "? 3 " << s[k1] << " " << s[k2] << " " << i << endl;
			int x; cin >> x;
			if (x == s[k1]) { // p[i] < p[s[k1]] < p[s[k2]]
				j2 = k1;
			} else if (x == i) { // p[s[k1]] < p[i] < p[s[k2]]
				j1 = k1 + 1;
				j2 = k2;
			} else { // p[s[k1]] < p[s[k2]] < p[i]
				j1 = k2 + 1;
			}
		}
		if (j1 == j2) {
			s.insert(s.begin() + j1, i);
		} else {
			if (j1 + 2 > s.size()) --j1;
			cout << "? 3 " << i << " " << s[j1] << " " << s[j1 + 1] << endl;
			int x; cin >> x;
			if (x == s[j1]) { // p[i] < p[s[j1]] < p[s[j1 + 1]]
				s.insert(s.begin() + j1, i);
			} else if (x == i) { // p[s[j1]] < p[i] < p[s[j1 + 1]]
				s.insert(s.begin() + j1 + 1, i);
			} else { // p[s[j1]] < p[s[j1 + 1]] < p[i]
				s.insert(s.begin() + j1 + 2, i);
			}
		}
	}

	cout << "!";
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (s[j] == i) {
				cout << " " << 1 + j;
			}
		}
	}
	cout << endl;
}
