#include <bits/stdc++.h>
using namespace std;

typedef long double ld;
typedef long long ll;

const ll INF = LLONG_MAX;
const int maxN = 1e5 + 10;

int n;

vector<int> g[maxN];
ll T[maxN];
int sz[maxN];

bool Q;

struct Line {
    mutable ll k, m, p;

    bool operator<(const Line &o) const {
        return Q ? p < o.p : k < o.k;
    }
};

struct LineContainer : multiset<Line> {
    ll div(ll a, ll b) { // floored division
        return a / b - ((a ^ b) < 0 && a % b);
    }

    bool isect(iterator x, iterator y) {
        if (y == end()) {
            x->p = INF;
            return false;
        }
        if (x->k == y->k) x->p = x->m > y->m ? INF : -INF;
        else x->p = div(y->m - x->m, x->k - y->k);
        return x->p >= y->p;
    }

    void add(ll k, ll m) {
        auto z = insert({k, m, 0}), y = z++, x = y;
        while (isect(y, z)) z = erase(z);
        if (x != begin() && isect(--x, y)) isect(x, y = erase(y));
        while ((y = x) != begin() && (--x)->p >= y->p)
            isect(x, erase(y));
    }

    ll query(ll x) {
        assert(!empty());
        Q = 1;
        auto l = *lower_bound({0, 0, x});
        Q = 0;
        return (l.k * x + l.m);
    }
};

int tin[maxN];
int tout[maxN];
int timer = 0;
LineContainer all[maxN];
int who[maxN];
int res[maxN];
ll best = INF;
LineContainer forVertical[maxN];

void dfs(int v, int p) {
    tin[v] = timer++;
    res[tin[v]] = v;
    int xx = -1;
    sz[v] = 1;
    for (int to : g[v]) {
        if (to == p) continue;
        dfs(to, v);
        sz[v] += sz[to];
        T[v] += 1LL * sz[to] * sz[to];
        if (xx == -1 || sz[to] > sz[xx]) {
            xx = to;
        }
    }
    if (xx == -1) {
        all[v].add(2 * (n - sz[v]), -T[v] - ((ll)n - sz[v]) * (n - sz[v]));
        forVertical[v].add(2 * sz[v], -T[v] - (ll)sz[v] * sz[v]);
        who[v] = v;
    } else {
        who[v] = who[xx];
        ll val = forVertical[who[v]].query(sz[xx]) - T[v] - ((ll)n - sz[v]) * ((ll)n - sz[v]);
        best = min(best, -val);
        for (int to : g[v]) {
            if (to == p) continue;
            if (to != xx) {
                ll val = forVertical[who[to]].query(sz[to]) - T[v] - ((ll)n - sz[v]) * ((ll)n - sz[v]);
                best = min(best, -val);
                for (int i = tin[to]; i < tout[to]; i++) {
                    int vert = res[i];
                    ll valF = all[who[v]].query(sz[vert]) - 1LL * sz[vert] * sz[vert] - T[vert];
                    best = min(best, -valF);
                }
                for (int i = tin[to]; i < tout[to]; i++) {
                    int vert = res[i];
                    all[who[v]].add(2 * (n - sz[vert]), -T[vert] - ((ll)n - sz[vert]) * (n - sz[vert]));
                    forVertical[who[v]].add(2 * sz[vert], -T[vert] - (ll)sz[vert] * sz[vert]);
                }
            }
        }
        all[who[v]].add(2 * (n - sz[v]), -T[v] - ((ll)n - sz[v]) * (n - sz[v]));
        forVertical[who[v]].add(2 * sz[v], -T[v] - (ll)sz[v] * sz[v]);
    }
    tout[v] = timer;
}

int main() {
    int t;
    cin >> t >> n;
    if (t == 1) {
        cout << 1LL * (n - 2) * (n - 2) << '\n';
        return 0;
    }
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    dfs(1, -1);
    cout << best << endl;
    return 0;
}
